<?php

use UnicaenCode\Form\AbstractForm;
use UnicaenCode\Form\ElementMaker;
use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Laminas\Mvc\Controller\AbstractController
 * @var $container  \Psr\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$cg = \UnicaenCode\Util::codeGenerator();

$params = [
    'title'  => 'Génération d\'une Classmap pour optimiser l\'autoload',
    'module' => [
        'label' => 'Module concerné',
        'type'  => 'selectModule',
    ],

    'generator' => function (array $params) {
        $moduleName = $params['module'];
        $module     = Util::introspection()->getModule($moduleName);
        $map        = Util::introspection()->getClasses($module['namespace']);

        $mc = 0;
        foreach ($map as $c => $f) {
            $lc = strlen($c);
            if ($lc > $mc) $mc = $lc;
        }
        $php = '';
        foreach ($map as $c => $f) {
            $php .= "    " . str_pad("'$c'", $mc + 2, ' ') . " => __DIR__ . '$f',\n";
        }

        $params['template'] = 'autoload_classmap';
        $params['filename'] = $module['relPath'] . '/autoload_classmap.php';
        $params['map']      = trim($php);

        return $params;
    },
];

$cg->generer($params);